#ifndef FRAMEWORK_KERNEL_QUOTES_MQH
#define FRAMEWORK_KERNEL_QUOTES_MQH

class kernel_quotes {
public:
	static double get_candle_value ( string symbol,
									 ENUM_TIMEFRAMES time_frame,
									 enum_candle_value_type type,
									 int shift ) {
		switch ( type ) {
			case candle_value_low: {
				double result[];
				return CopyLow ( symbol,time_frame, shift, 1, result ) > 0 ? result[0] : -1;
			}

			case candle_value_close: {
				double result[];
				return CopyClose ( symbol,time_frame, shift, 1, result ) > 0 ? result[0] : -1;
			}

			case candle_value_open: {
				double result[];
				return CopyOpen ( symbol,time_frame, shift, 1, result ) > 0 ? result[0] : -1;
			}

			case candle_value_high: {
				double result[];
				return CopyHigh ( symbol,time_frame, shift, 1, result ) > 0 ? result[0] : -1;
			}

			default:
				return -1;
		}
	}

	static datetime get_candle_open_time ( string symbol,
										   ENUM_TIMEFRAMES time_frame,
										   int shift ) {
		datetime result[];
		return (CopyTime ( symbol, time_frame , shift, 1, result ) > 0 ? result[0] : -1);
	}

};

#endif